; ZTKUTL.sc         Alan Zenreich   Version 1.0   6/4/88

; Greetings, due to popular demand I've included several of the utility
; proc that I use in the data entry toolkit.   I have not had the time to
; fully comment the code, but I think you'll get the idea.
;
; Many of the procs are "extentions" to those found in MAKEDEMO.sc that comes
; with the toolkit demo.
;
; Some, like azLookupSelect() are work arounds to things that drove me mad
; early on.  I hope more folk use the toolkit, it is extremely powerful, but
; not for the weak of heart.....
;
; Others, like azOkKey and azZoom are uniquely mine, used to do things "MY WAY"
; with me in control of the user's keystrokes.
;
; This script reperesents part of my arsenal of PAL code that I draw upon
; when starting a new application.  I try to keep it generic, so I don't have
; to write any more new code than necessary.


zaplibname="Your lib name here"


;==================================================================
; before I use DETOOL, I assign two variables for my prompt lines:
; zprompt1 and zprompt2
; and issue a  PROMPT zprompt1,zprompt2     command
; Now if the user moves onto a field that I want to flag as having field help,
; I simply use azHelpPrompt() as an arrive proc and azSetPrompt() as a depart
; proc.


PROC azhelpprompt()      ; called by fields for which there is a lookup
  PROMPT zprompt1+"  [F1]-FieldHelp",zprompt2         ; zprompt s set in application
ENDPROC
WRITELIB zaplibname azhelpprompt
RELEASE PROCS azhelpprompt

;==================================================================
PROC azsetprompt()      ; resets prompt to zprompt1+zprompt2
  PROMPT zprompt1,zprompt2
ENDPROC
WRITELIB zaplibname azsetprompt
RELEASE PROCS azsetprompt

;==================================================================


;=======
PROC azReqd()
  PRIVATE z,zfield,zvowel
  IF IsBlank([]) AND TKChar<>-83
    AND TKChar<>21 AND TKChar<>0  THEN
    TKAccept=False     ;Ignore movement key that was pressed (Stay here)

    zfield=(FIELD())    ; get field name
    z=UPPER(SUBSTR(zfield,1,1))   ; get first character of field
    BEEP
    zvowel= "AEIOU"

    IF SEARCH(z,zvowel)>0 THEN
                        ; a vowel
      TKMessage="An "+zfield+" must be provided."    ;keep A An straight
    ELSE
                        ; a consonant for field name
      TKMessage="A "+zfield+" must be provided."
    ENDIF
  ELSE
    azsetprompt()   ; resets to the default prompt   ; see code below
  ENDIF
ENDPROC
WRITELIB zaplibname azReqd
RELEASE PROCS azReqd

;============================================================================

PROC azdisplayonly()   ; as soon as cursor is moved into the field it
        ; will jump out simulating a display only field.
        ;

  IF TKChar=-15 OR TKChar=-75 OR TKChar=-72 ;Did we arrive from right?
    THEN
    Left                          ; Yes- Continue along
  ELSE
    Right                          ; No-  Move to the right
  ENDIF
  ArriveField()  ;We have left the field explicitly (unexpectedly),
        ; thus we must tell DoWait that we are arriving in  a new field
ENDPROC
WRITELIB zaplibname azdisplayonly
RELEASE PROCS       azdisplayonly
;============================================================================


;============================================================================

PROC azdisplayNoUp()   ; if cursor arrives on field, it is moved back down
  Right                ; used for the first field on a form.
  ArriveField()  ;We have left the field explicitly (unexpectedly),
        ; thus we must tell DoWait that we are arriving in  a new field
ENDPROC
WRITELIB zaplibname azdisplayNoup
RELEASE PROCS       azdisplayNoup
;============================================================================

; This procedure does not allow the up arrow to be pressed.  It is used to
; disallow departure from a record in form view, and is called upon departure
; from the First field in a table     see also azreqdNoUpLeft
;
PROC azNoUp()
  IF TKChar=-72
    THEN
    BEEP
    TKAccept=False
  ENDIF
ENDPROC
WRITELIB zaplibname azNoUp
RELEASE PROCS azNoUp



; This procedure does not allow the up or left arrows to be pressed.  It is
; used to disallow departure from a record in form view, and is called upon
; departure from the Last Name field of the Customer table.
;
PROC azNoUpLeft()
  IF TKChar=-72 OR TKChar=-75 OR TKChar=-15
    THEN
    BEEP
    TKAccept=False
  ENDIF
ENDPROC
WRITELIB zaplibname azNoUpLeft
RELEASE PROCS azNoUpLeft


PROC azReqdNoUL()
  PRIVATE z,zfield
  azreqd()  ; do the required proc
  IF TKChar=-72 OR TKChar=-75 OR TKChar=-15 THEN

    BEEP                ; don't want to move to the record above
    TKAccept=False
                ; arrivefield()   ; resets the help prompt
  ELSE
                ; might try to move to another field down and therefore
    azsetprompt() ; need to reset the prompt upon leaving the field
  ENDIF

ENDPROC
WRITELIB zaplibname azReqdNoUL
RELEASE PROCS azReqdNoUL


; This procedure does not allow the down or right arrows to be pressed.  It is
; used to disallow departure from a record in form view, and is called upon
; departure from the Discount field of the Customer table.
;
PROC azReqdNoDR()
  azreqd() ; do reqd proc
  IF TKChar=13 OR TKChar=-77 OR TKChar=9 OR TKChar=-80
    THEN
    BEEP
    TKAccept=False
  ENDIF
ENDPROC
WRITELIB zaplibname azReqdnoDR
RELEASE PROCS azReqdNoDR

;==============================================
; used to prohibit moving to next record when in lower right hand corner of form

PROC azNoDownRight()
  IF TKChar=13 OR TKChar=-77 OR TKChar=9 OR TKChar=-80
            ; enter   or       right  or tab             down
    THEN
    BEEP
    TKAccept=False
  ENDIF
ENDPROC
WRITELIB zaplibname azNoDownRight
RELEASE PROCS azNoDownRight

; This procedure does not allow the down arrow to be pressed.  It is
; used to disallow departure from a record in form view, and is called upon
; departure from the Discount field of the Customer table.
;
PROC azNoDown()
  IF  TKChar=-80     ; down
    THEN
    BEEP
    TKAccept=False
  ENDIF
ENDPROC
WRITELIB zaplibname azNoDown
RELEASE PROCS azNoDown


; AZOKKEY()     version 2.0  3/35/88

; Copyright  Alan Zenreich     Zenreich Systems 212-619-0170
;
;
; This proc was developed to trap for key violations in Coedit mode in real time
; upon GoodDepart DEToolkit procedure, but could probably be used at any time.
;
; The goal is to return a TRUE or FALSE that tells the calling program whether
; or not the proposed key is "OK"
;
; However, the issue is somewhat complicated.  I want to remain on the
; record, and not let it "FLY" away from me.
;
; I also want to deal with someone entering a valid key, then going back,
; changing their mind, and replacing the valid key with a conflicting key.
; The proc should trap for this occurance.
;
; Issues that need to be resolved include:
;  If record is not yet posted to table (a new record) we want to keep it
;   that way until ready to commit it.
;  If we are editing an existing record and change the key, how does this
;   affect other records that depend on it (Should the user be allowed to
;   change the key in the first place)
;  If it ok to change a key, and the user accidentally changes it to an existing
;   key, then we have to deal with it in a special way, since we are in a
;   mode that Paradox insists that we correct immediately.
;  Do we want to show the user the offending key, and have them toggle?
;  Do we want to tell the user that the key is already on file, and refuse the
;   change?
;  If we use the technique in the code below, if a key conflict exists, the
;    record is deleted and then reinserted to make it an unposted record.
;    What happens if the user wants to "UNDO" his or her changes?
;    When does the record disappear from other nodes on the network?
;    If another user attempts to edit the reocord on their node, do they get a
;     "Record deleted by another user" message?
;
; So..... here goes.  At this writing I think it works ok, but need to see if
; I am overlooking something...
; Obviously I would prefer an ISKEYVALID() fuction from within PAL.
;
;
; The following proc checks for key violation in coedit mode.
; If key already exists and the proc deletes the record and then reinserts it,
; returning it to a "not yet posted" state.

; This avoids a potential problem where a record is locked, and when the next
; attempt to lock or unlock the record occurs and we come up with a
; "key already exists" situation, any future LOCKRECORD or UNLOCKRECORD
; will automatically post the offending record, overriding the record that
; already has the valid key.  This is not usually what we want, so the record
; is placed as not yet posted, to make it relatively harmless.
;
zaplibname="toolkit"   ; assign library to write to

PROC azOkKey()     ;assumes coedit mode and returns a true or false
  PRIVATE zconflict
  ECHO OFF
  CopyToArray zconflict
  DEL
  Ins            ; need an unposted record to  check
  CopyFromArray zconflict
  KeyLookup     ; attempt lookup toggle to possible offending key
  IF ERRORCODE()=56 THEN   ; lookupkey not found
    LockRecord
    RETURN true
  ENDIF
  KeyLookup  ; return to record values as operator entered
  ; your error message wuold go here**********
  ;  azerror("A record with this key is already on file.",
  ;  "Press any key to continue",1000)
                       ; or whatever error message procedure you want
  RETURN false
ENDPROC

WRITELIB zaplibname azOkKey
RELEASE PROCS       azOkKey
;============================================================================


;============================================================================

; Contains Licensed Material Copyright (C) 1987 Ansa Software -- MJP

; This procedure mimics a WAIT command in lookup help.  Unfortunately, although
; you can enter into lookup help from within a WAIT, you cannot enter into a
; WAIT from within lookup help.  Thus if the programmer wishes to provide the
; user access to the lookup help table, and a WAIT is not currently in effect,
; he/she must call this procedure.  THIS PROCEDURE WILL FUNCTION ONLY ON LOOKUP
; HELP TABLES.
;
; Please note that the procedure turns echo to normal in order to display the
; lookup table, and turns echo off upon exit.  This is different from the WAIT
; command which leaves the echo status unchanged.
;
; The procedure will return the ASCII value of the key that was pressed which
; caused the wait to be left (either Esc or Do_It!).  As with the WAIT comand,
; control will be passed back to the caller BEFORE the key is acted upon.
;
; *** AZ modifications include changing the prompt, and mapping out of the
; troublesome ZOOM key, see azZoom for more details.




PROC azLookupSelect()
  PRIVATE z

  ECHO   NORMAL             ;Display the table to the user
  RETVAL=0
  PROMPT "Press [F2] to select record, [Esc] to cancel",
  "[Ctrl Z] zooms to a field value, [Alt Z] zooms to the next occurrence"
  WHILE True
    RETVAL=GETCHAR()
    SWITCH
      CASE RETVAL=-59: ; press F1     ; az modification, don't want PDOX help!!
        BEEP
      CASE HelpMode()="LookupHelp" AND     ;We could be in HELP or HELP INDEX
        (RETVAL=-60 OR RETVAL=27 OR RETVAL=0):
        QUITLOOP
      CASE RETVAL=26: ; press zoom         az modification
        azzoom()
        ECHO NORMAL  ; since azzoom turns it off
      OTHERWISE: KEYPRESS RETVAL
    ENDSWITCH
  ENDWHILE
        ;*****   azhelpprompt()   ; probably not necessary
  ECHO OFF      ; try deleting line
  SYNCCURSOR    ;

  IF RETVAL=0               ;CtrlBreak functions the same as Esc. Thus return
    THEN
    RETVAL=27         ; the code for Esc unless Do_It! is pressed
  ENDIF
  RETURN RETVAL
ENDPROC
WRITELIB zaplibname azlookupselect
RELEASE PROCS azlookupselect

;===========================

; Copyright Alan Zenreich 1987       Zenreich Systems  (212) 691-0170
;
; Procedure to map out erroneous keys during zoom.
; The problem:  Zoom is not enough of a world unto itself.
;
; Example 1:
;
;    View "Customer"
;    PICKFORM 1
;    WHILE TRUE
;      WAIT TABLE
;      PROMPT "Viewing Customer table",
;             "Press [F7] to toggle FormView, or [Esc] to quit"
;      UNTIL  "F7","Esc"
;      SWITCH
;        CASE retval="F7":
;          FormKey            ; toggle form view
;        CASE retval="Esc":
;          CLEARIMAGE         ; remove the table from the workspace
;          QUITLOOP           ; exit the loop
;      ENDSWITCH
;    ENDWHILE

; The example above is a simple demonstration of a WAIT TABLE condition.
; Pressing [F7] toggles form view, and [Esc] clears the table.
;
; In this case most keys work as expected.  However there are some very notable
; exceptions.  If you press [F1] and are NOT in a field with a tablelookup
; help, the computer beeps as it should, because PARADOX help is not normally
; available to the user from within a script.
;
; The problem arises when Zoom is used. If you press [Ctrl Z] (Zoom),
; a prompt appears at the top of the screen asking you for the Zoom value.
; 1) If you press [Esc] to exit the Zoom prompt you WILL satisfy the WAIT UNTIL
;    condition, clear the table, and exit the loop, which is clearly not wanted
;    at this point!
;
; 2) If you press [F1] while the Zoom prompt is onscreen, you will get
;    PARADOX help!.  This is not usually desirable in a script situation.
;
; 2) To further complicate the problem, if you press [Esc] to exit the PARADOX
;    help system, the [Esc] keypress will satisfy the WAIT UNTIL condition, and
;    clear the table.
;
;    If this isn't nasty enough (since your table just got cleared out from
;    under you), in version 2.0, clearing a table while the Zoom prompt is up
;    and then trying to escape from the Zoom prompt (which is still on the
;    screen) will send you directly out of Paradox and back to DOS.
;
;    (By the way, the last problem was fixed in version 2.01.  Now if you
;     View a table, Press [Ctrl Z], and press [F8] to clear the image, the Zoom
;     prompt also clears.  So at least the error won't dump you out of Paradox.)

;  In order to keep the user from seeing interactive PARADOX help and totally
;  avoiding the zoom related problems, I have created azZoom().
;
;  The proc traps for function keys (except FieldView) and for invalid zooms.

;============================================================================
; Example 2: This script allows the WAIT condition to trap for the Zoom keypress
;


;    View "customer"
;    PICKFORM 1
;    WHILE TRUE
;      WAIT TABLE
;      PROMPT "Viewing Customer table",
;             "Press [F7] to toggle FormView, or [Esc] to quit"
;      UNTIL  "F7","Esc","Zoom","Enter"
;      SWITCH
;        CASE retval="Zoom":
;          azZoom()           ; handles all zoom related problems
;        CASE retval="F7":
;          FormKey            ; toggle form view
;        CASE retval="Esc" or retval="Enter":
;          beep beep beep
;          CLEARIMAGE         ; remove the table from the workspace
;          QUITLOOP           ; exit the loop
;      ENDSWITCH
;    ENDWHILE
;============================================================================

PROC azZoom()
  PRIVATE z,zisfieldview
  Zoom                 ; presses the Zoom key
  echo NORMAL          ; turn echo on so operator can see keypresses
  zisfieldview=false
  WHILE true
    z=GETCHAR()        ; wait for operators keypress
    SWITCH
      CASE  z=-108 OR z=6 :    ; [Alt F5] fieldview or ctrl f

        KEYPRESS z
        zisfieldview=true      ; need this to pass the enter to the zoom when
                                       ; fieldview is finished

      CASE  z=-71 OR   ; Home       ; accounts for possible FieldView while
        z=-75 OR       ; Left       ; in Zoom prompt
        z=-77 OR       ; Right
        z=-79 OR       ; End
        z=-82 OR       ; Ins
        z=-83 :
        KEYPRESS z                  ; press the key

      CASE z<-15 :                  ; includes unwanted function keys
        BEEP                        ; beep on error

      CASE zisfieldview AND  z=13 : ; user pressed [Enter] while in field view
        Enter                       ; end field view
        zisfieldview=false

      CASE z=-15 OR z=13:           ; user pressed [Enter]
        tkecho OFF
        ;       Select menuchoice()
        KEYPRESS z                  ; press the key as if the user typed it
        SWITCH
          CASE WINDOW()="":         ; match was found
            RETURN
          CASE WINDOW()="Match not found":
            BEEP                    ; signal user that match was not found
            RETURN
          OTHERWISE:             ; wrong data type, or number out of range
            BEEP
            MESSAGE WINDOW()     ; present errormessage to user
            SLEEP 2000           ; let user read message, will loop back to top
            echo NORMAL
        ENDSWITCH

      CASE z=27:                    ; pressed [Esc]
        echo OFF
        Esc                         ; get out of zoom with Esc instead of
             ;  keypress z
        RETURN                      ; keypress z.  Esc command does not activate
                                            ; the UNTIL condition

      OTHERWISE:                    ; any legitimate key
        KEYPRESS z                  ; press the user's key
    ENDSWITCH
  ENDWHILE
ENDPROC   ; azZoom
WRITELIB zaplibname azZoom
RELEASE PROCS       azZoom
;==============================================================================

